c-23          Program  effectsampsizedob
chelpini
c_______________________________________________________________
c
c Objetivo:   It calculates the effective sample size of two timeseries that
c           are going to be regressed or correlated
c
c Metodo:       Obvious
c Comentarios: 
c              It considers a conservative approach, by selecting the largest
c            critical lag in both timeseries 
c________________________________________________________________
chelpfin
c.....Definicion de variables
c
      parameter(nr=4,ntp=2000,nspa=10000,spval=9.E9)  
      integer ia(nr),ia2(nr)
      real ac1(ntp),ac2(ntp,nspa),clag1,clag2(nspa),clag
      real neff(nspa),sum
      character*64 in1,in2,in3,in4,out
c
c
c.....Input nombres de ficheros 
c
      write (*,*)'Autocorrelations of file 1 (timeseries)?'
      read(*,150)in1
      write (*,*)'Autocorrelations of file 2 (field)?'
      read(*,150)in2
      write(*,*)'Critical lag in file 1?'
      read(*,150)in3
      write(*,*)'Critical lag in file 2?'
      read(*,150)in4
      write(*,*)'Output file?'
      read(*,150)out
c
150   format(a64)
c
c.....Apertura de ficheros
c

      open(10,file=in1,status='unknown',form='unformatted')
      open(20,file=in2,status='unknown',form='unformatted')
      open(11,file=in3,status='unknown',form='unformatted')
      open(21,file=in4,status='unknown',form='unformatted')

      open(30,file=out,status='unknown',form='unformatted')

c
c..... 
c

c     Reading the autocorrelations of file 1 and 2

      k=1

 10   continue

      read(10,end=999)ia
      read(10)ac1(k)

      read(20)ia2
      read(20)(ac2(k,i),i=1,ia2(4))
      
      
      k=k+1
      go to 10


 999  continue 
      
      ntot=k-1


c     Now we read the critical lags

      read(11)ia
      read(11)clag1

c      print*,ia2(4)
      read(21)ia2
      read(21)(clag2(i),i=1,ia2(4))


c     Finally we apply the corresponding formula to correct the sample size


      do j=1,ia2(4)

         if (clag2(j).eq.spval) then

          neff(j)=spval
c         print*,j,spval
         else

          if (clag1.ge.clag2(j)) then
            clag=clag1
          else
            clag=clag2(j)
          endif
           sum=0.
          do i=1,clag  ! Loop to do the summatory   
           sum=sum+2*(1-i/ntot)*ac1(i)*ac2(i,j)
          enddo

          neff(j)=ntot/(1+sum)

         endif
         

      enddo

      ia2(1)=10000130

       write(30)ia2
       write(30)(neff(j),j=1,ia2(4))




c$$$        p(i)=x(i)**2
c$$$        sum=sum+p(i)
c$$$        var=(1+(2*sum))/nser
c$$$        desv=sqrt(var)
c$$$        crit(i)=desv*1.96
c$$$c        write(4,*)i,x(i),crit(i)
c$$$        if (x(i).ge.crit(i)) then
c$$$        y(i)=x(i)
c$$$        else 
c$$$        y(i)=0
c$$$        endif
c$$$c Ahora se calcula la longitud efectiva de la muestra
c$$$
c$$$        val(i)=(1-(i/nser))*y(i)
c$$$        suma=suma+val(i)
c$$$        tam(i)=1+(2*suma)   
c$$$        write(4,160)i,x(i),crit(i),y(i),tam(i)
c$$$        i=i+1
c$$$
c$$$        end do
c$$$c       
c$$$        k=i-1  
c$$$        nefec=int(nser/tam(k))
c$$$        write(11,170)k,tam(k),nser,nefec
c$$$
c$$$ 160    format(i2,2x,f6.3,2x,f6.3,2x,f6.3,2x,f7.3)
c$$$ 170    format(i2,2x,f7.3,2x,f7.3,2x,i3)
      stop
      end
c
