% Load DNA copy-number data
clear all; clc; close all

% Past1000-Rni1 and PiControl-P
LL = 4;
x = zeros(999,LL);
figure(1);
c = [0.6 0.6 0.6];
R = ceil(sqrt(LL));
C = ceil(LL/R);

for i = 1:LL
    subplot(R,C,i);
    hold on;
    
    if i==1
        y = double(ncread('/scratch/local1/m300281/past1000_R3/ocean/SPGStrength_MPI-ESM-P_past1000_r3i1p1.nc','E342'));
        name{1} = 'Past1000-R3i1';
    elseif i==2
        y = double(ncread('/scratch/local1/m300281/past1000_R2/ocean/SPGStrength_MPI-ESM-P_past1000_r2i1p1.nc','E242'));
        name{1} = 'Past1000-R2i1';
    elseif i==3
        y = double(ncread('/scratch/local1/m300281/past1000_R1/ocean/SPGStrength_MPI-ESM-P_past1000_r1i1p1.nc','E028'));
        name{1} = 'Past1000-R1i1';
    elseif i==4
        y = double(ncread('/scratch/local1/m300281/control/ocean/SPGStrength_Oyr_MPI-ESM-P_piControl_r1i1p1_1850-3005.nc','E238'));
        name{1} = 'PiControl-P';
    end
    
    y=y(1:1000);
    a = autocorr(y); a = a(2);
    
    x(:,i) = l1pwcar1(y, 8, a);
    
    plot(y,'Color',c,'LineWidth',1);
    plot(x(:,i),'b-','LineWidth',2);
    %legend({'Original time series','Steps in mean level'},'Location','southwest','FontSize',11,'FontWeight','bold')
    %box on;
    axis tight;
    title(char(name{1}),'FontSize',11,'fontweight','bold');
    xlabel('Time (Years)','fontweight','bold','fontsize',11);
    
end

% save('step_functions.dat','x','-ascii');
%stop
% Sensitivity Experiments
LL = 9;
x = zeros(849,LL);
figure(2);
c = [0.6 0.6 0.6];
R = ceil(sqrt(LL));
C = ceil(LL/R);

for i = 1:LL
    subplot(R,C,i);
    hold on;
    
    if i==1
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SPGStrength_MPI-ESM-P_past1000_r3i2p1_0850-1749.nc','SPGR32'));
        name{1} = 'Past1000-R3i2';
    elseif i==2
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SPGStrength_MPI-ESM-P_past1000_r3i3p1_0850-1749.nc','SPGR33'));
        name{1} = 'Past1000-R3i3';
    elseif i==3
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SPGStrength_MPI-ESM-P_past1000_r3i4p1_0850-1749.nc','SPGR34'));
        name{1} = 'Past1000-R3i4';
    elseif i==4
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SPGStrength_MPI-ESM-P_past1000_r3i5p1_0850-1749.nc','SPGR35'));
        name{1} = 'Past1000-R3i5';
    elseif i==5
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SPGStrength_MPI-ESM-P_past1000_r3i6p1_0850-1699.nc','SPGR36'));
        name{1} = 'Past1000-R3i6';
    elseif i==6
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SPGStrength_MPI-ESM-P_past1000_r3i7p1_0850-1699.nc','SPGR37'));
        name{1} = 'Past1000-R3i7';
    elseif i==7
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SPGStrength_MPI-ESM-P_past1000_r3i8p1_0850-1699.nc','SPGR38'));
        name{1} = 'Past1000-R3i8';
    elseif i==8
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SPGStrength_MPI-ESM-P_past1000_r3i9p1_0850-1699.nc','SPGR39'));
        name{1} = 'Past1000-R3i9';
    else i==9
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SPGStrength_MPI-ESM-P_past1000_r3i10p1_0850-1699.nc','SPGR310'));
        name{1} = 'Past1000-R3i10';
    end
    
    y=y(1:850);
    a = autocorr(y); a = a(2);
    
    x(:,i) = l1pwcar1(y, 8, a);
    
    plot(y(600:849),'Color',c,'LineWidth',1);
    plot(x(600:849,i),'b-','LineWidth',2);
    %legend({'Original time series','Steps in mean level'},'Location','southwest','FontSize',9,'FontWeight','bold')
    %box on;
    axis tight;
    title(char(name{1}),'FontSize',11,'fontweight','bold');
    xlabel('Time (Years)','fontweight','bold','fontsize',11);
    
end

hold off


