% Load DNA copy-number data
clear all; clc; close all

% Sensitivity Experiments
LL = 10;
x = zeros(849,LL);
figure(2);
c = [0.6 0.6 0.6];
R = ceil(sqrt(LL));
C = ceil(LL/R);

for i = 1:LL
    subplot(R,C,i);
    hold on;
    
    if i==1
        y = double(ncread('/scratch/local1/m300281/past1000_R717s/scripts/ncs_timeseries/SSS_LabSea_MPI-ESM-P_past1000_r17i1p1.nc','VAR1'));
        name{1} = 'Past1000-R17i1';
    elseif i==2
        y = double(ncread('/scratch/local1/m300281/past1000_R717s/scripts/ncs_timeseries/SSS_LabSea_MPI-ESM-P_past1000_r17i2p1.nc','VAR1'));
        name{1} = 'Past1000-R17i2';
    elseif i==3
        y = double(ncread('/scratch/local1/m300281/past1000_R717s/scripts/ncs_timeseries/SSS_LabSea_MPI-ESM-P_past1000_r17i3p1.nc','VAR1'));
        name{1} = 'Past1000-R17i3';
    elseif i==4
        y = double(ncread('/scratch/local1/m300281/past1000_R717s/scripts/ncs_timeseries/SSS_LabSea_MPI-ESM-P_past1000_r17i4p1.nc','VAR1'));
        name{1} = 'Past1000-R17i4';
    elseif i==5
        y = double(ncread('/scratch/local1/m300281/past1000_R717s/scripts/ncs_timeseries/SSS_LabSea_MPI-ESM-P_past1000_r17i5p1.nc','VAR1'));
        name{1} = 'Past1000-R17i5';
    elseif i==6
        y = double(ncread('/scratch/local1/m300281/past1000_R717s/scripts/ncs_timeseries/SSS_LabSea_MPI-ESM-P_past1000_r17i6p1.nc','VAR1'));
        name{1} = 'Past1000-R17i6';
    elseif i==7
        y = double(ncread('/scratch/local1/m300281/past1000_R717s/scripts/ncs_timeseries/SSS_LabSea_MPI-ESM-P_past1000_r17i7p1.nc','VAR1'));
        name{1} = 'Past1000-R17i7';
    elseif i==8
        y = double(ncread('/scratch/local1/m300281/past1000_R717s/scripts/ncs_timeseries/SSS_LabSea_MPI-ESM-P_past1000_r17i8p1.nc','VAR1'));
        name{1} = 'Past1000-R17i8';
    elseif i==9
        y = double(ncread('/scratch/local1/m300281/past1000_R717s/scripts/ncs_timeseries/SSS_LabSea_MPI-ESM-P_past1000_r17i9p1.nc','VAR1'));
        name{1} = 'Past1000-R17i9';
    elseif i==10
        y = double(ncread('/scratch/local1/m300281/past1000_R717s/scripts/ncs_timeseries/SSS_LabSea_MPI-ESM-P_past1000_r17i10p1.nc','VAR1'));
        name{1} = 'Past1000-R17i10';
    end
    
    y=y(1:850);
    a = autocorr(y); a = a(2);
    
    x(:,i) = l1pwcar1(y, 1, a);
    
    plot(y(600:849),'Color',c,'LineWidth',1);
    plot(x(600:849,i),'b-','LineWidth',2);
    %legend({'Original time series','Denoised time series'},'Location','southwest','FontSize',11,'FontWeight','bold')
    %box on;
    axis tight;
    title(char(name{1}),'FontSize',11,'fontweight','bold');
    xlabel('Time (Years)','fontweight','bold','fontsize',11);
    
end

hold off


