% Load DNA copy-number data
clear all; clc; close all

% Past1000-R3i1 -> Target
y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SSS-LabSea_MPI-ESM-P_past1000_r3i1p1_0850-1849.nc','SSS'));
y=y(1:900);
a = autocorr(y); a = a(2);

name{1} = 'Past1000-R3i1';
figure(1);
LL = 1;
x = zeros(899,LL);

x(:,1) = l1pwcar1(y, 1, a);

c = [0.6 0.6 0.6];
R = ceil(sqrt(LL));
C = ceil(LL/R);

for i = 1:LL
    subplot(R,C,i);
    hold on;
    plot(y,'Color',c,'LineWidth',1);
    plot(x(:,i),'b-','LineWidth',2);
    %legend({'Original time series','Denoised time series'},'Location','southwest','FontSize',11,'FontWeight','bold')
    %box on;
    axis tight;
    title(char(name{i}),'FontSize',11,'fontweight','bold');
    xlabel('Time (Years)','fontweight','bold','fontsize',11);
    
end

% Sensitivity Experiments
LL = 9;
x = zeros(849,LL);
figure(2);
c = [0.6 0.6 0.6];
R = ceil(sqrt(LL));
C = ceil(LL/R);

for i = 1:LL
    subplot(R,C,i);
    hold on;
    
    if i==1
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SSS-LabSea_MPI-ESM-P_past1000_r3i2p1_0850-1749.nc','SSTI2'));
        name{1} = 'Past1000-R3i2'
    elseif i==2
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SSS-LabSea_MPI-ESM-P_past1000_r3i3p1_0850-1749.nc','SSTI3'));
        name{1} = 'Past1000-R3i3';
    elseif i==3
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SSS-LabSea_MPI-ESM-P_past1000_r3i4p1_0850-1749.nc','SSTI4'));
        name{1} = 'Past1000-R3i4';
    elseif i==4
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SSS-LabSea_MPI-ESM-P_past1000_r3i5p1_0850-1749.nc','SSTI5'));
        name{1} = 'Past1000-R3i5';
    elseif i==5
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SSS-LabSea_MPI-ESM-P_past1000_r3i6p1_0850-1699.nc','SSTI6'));
        name{1} = 'Past1000-R3i6';
    elseif i==6
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SSS-LabSea_MPI-ESM-P_past1000_r3i7p1_0850-1699.nc','SSTI7'));
        name{1} = 'Past1000-R3i7';
    elseif i==7
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SSS-LabSea_MPI-ESM-P_past1000_r3i8p1_0850-1699.nc','SSTI8'));
        name{1} = 'Past1000-R3i8';
    elseif i==8
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SSS-LabSea_MPI-ESM-P_past1000_r3i9p1_0850-1699.nc','SSTI9'));
        name{1} = 'Past1000-R3i9';
    else i==9
        y = double(ncread('/scratch/local1/m300281/newpast1000-R3s/scripts/ncs_timeseries/SSS-LabSea_MPI-ESM-P_past1000_r3i10p1_0850-1699.nc','SSTI10'));
        name{1} = 'Past1000-R3i10';
    end
    
    y=y(1:850);
    a = autocorr(y); a = a(2);
    
    x(:,i) = l1pwcar1(y, 1, a);
    
    plot(y(600:849),'Color',c,'LineWidth',1);
    plot(x(600:849,i),'b-','LineWidth',2);
    %legend({'Original time series','Denoised time series'},'Location','southwest','FontSize',11,'FontWeight','bold')
    %box on;
    axis tight;
    title(char(name{1}),'FontSize',11,'fontweight','bold');
    xlabel('Time (Years)','fontweight','bold','fontsize',11);
    
end

hold off;