% Load DNA copy-number data
clear all; clc; close all

% Sensitivity Experiments
LL = 10;
x = zeros(849,LL);
figure(2);
c = [0.6 0.6 0.6];
R = ceil(sqrt(LL));
C = ceil(LL/R);

for i = 1:LL
    subplot(R,C,i);
    hold on;
    
    if i==1
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r17i1.nc','TOTR17I1')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R17i1';
    elseif i==2
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r17i2.nc','TOTR17I2')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R17i2';
    elseif i==3
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r17i3.nc','TOTR17I3')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R17i3';
    elseif i==4
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r17i4.nc','TOTR17I4')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R17i4';
    elseif i==5
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r17i5.nc','TOTR17I5')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R17i5';
    elseif i==6
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r17i6.nc','TOTR17I6')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R17i6';
    elseif i==7
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r17i7.nc','TOTR17I7')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R17i7';
    elseif i==8
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r17i8.nc','TOTR17I8')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R17i8';
    elseif i==9
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r17i9.nc','TOTR17I9')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R17i9';
    elseif i==10
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r17i10.nc','TOTR17I10')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R17i10';
    end
    
    y=y(1:850);
    a = autocorr(y); a = a(2);
    
    x(:,i) = l1pwcar1(y, 3000, a);
    
    plot(y(600:849),'Color',c,'LineWidth',1);
    plot(x(600:849,i),'b-','LineWidth',2);
    %legend({'Original time series','Denoised time series'},'Location','southwest','FontSize',11,'FontWeight','bold')
    %box on;
    axis tight;
    title(char(name{1}),'FontSize',11,'fontweight','bold');
    xlabel('Time (Years)','fontweight','bold','fontsize',11);
    x(770,i)-x(740,i)
end

hold off


