% Load DNA copy-number data
clear all; clc; close all

% Past1000-R3i1 -> Target
y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r3i1.nc','TOTR3I1')))*3600*24*365.25/1E9;
y=y(1:900);
a = autocorr(y); a = a(2);

name{1} = 'Past1000-R3i1';
figure(1);
LL = 1;
x = zeros(899,LL);

x(:,1) = l1pwcar1(y, 3000, a);

c = [0.6 0.6 0.6];
R = ceil(sqrt(LL));
C = ceil(LL/R);

for i = 1:LL
    subplot(R,C,i);
    hold on;
    plot(y,'Color',c,'LineWidth',1);
    plot(x(:,i),'b-','LineWidth',2);
    %legend({'Original time series','Denoised time series'},'Location','southwest','FontSize',11,'FontWeight','bold')
    %box on;
    axis tight;
    title(char(name{i}),'FontSize',11,'fontweight','bold');
    xlabel('Time (Years)','fontweight','bold','fontsize',11);
    
end

hold off 

x(770)-x(740)



% Sensitivity Experiments
LL = 9;
x = zeros(849,LL);
figure(2);
c = [0.6 0.6 0.6];
R = ceil(sqrt(LL));
C = ceil(LL/R);

for i = 1:LL
    subplot(R,C,i);
    hold on;
    
    if i==1
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r3i2.nc','TOTR3I2')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R3i2'
    elseif i==2
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r3i3.nc','TOTR3I3')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R3i3';
    elseif i==3
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r3i4.nc','TOTR3I4')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R3i4';
    elseif i==4
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r3i5.nc','TOTR3I5')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R3i5';
    elseif i==5
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r3i6.nc','TOTR3I6')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R3i6';
    elseif i==6
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r3i7.nc','TOTR3I7')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R3i7';
    elseif i==7
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r3i8.nc','TOTR3I8')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R3i8';
    elseif i==8
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r3i9.nc','TOTR3I9')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R3i9';
    elseif i==9
        y = squeeze(double(ncread('/home/zmaw/m300281/actual_trabajo/paper2Figs/indices/TOTFWTR/TOTFWTR_yr_past1000-r3i10.nc','TOTR3I10')))*3600*24*365.25/1E9;
        name{1} = 'Past1000-R3i10';
    end
    
    y=y(1:850);
    a = autocorr(y); a = a(2);
    
    x(:,i) = l1pwcar1(y, 3000, a);
    
    plot(y(600:849),'Color',c,'LineWidth',1);
    plot(x(600:849,i),'b-','LineWidth',2);
    %legend({'Original time series','Denoised time series'},'Location','southwest','FontSize',11,'FontWeight','bold')
    %box on;
    axis tight;
    title(char(name{1}),'FontSize',11,'fontweight','bold');
    xlabel('Time (Years)','fontweight','bold','fontsize',11);
    x(770,i)-x(740,i)
end

hold off;


